[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| VariableImportanceVisitor [Machine Learning] |

`#include <vigra/random_forest/rf_visitors.hxx>`

Inheritance diagram for VariableImportanceVisitor:

List of all members.

## Public Member Functions
template<class RF, class PR, class SM, class ST>
void | after_tree_ip_impl (RF &rf, PR &pr, SM &sm, ST &st, int index)
| VariableImportanceVisitor (int rep_cnt=10)
template<class Tree, class Split, class Region, class Feature_t, class Label_t>
void | visit_after_split (Tree &tree, Split &split, Region &parent, Region &leftChild, Region &rightChild, Feature_t &features, Label_t &labels)
template<class RF, class PR, class SM, class ST>
void | visit_after_tree (RF &rf, PR &pr, SM &sm, ST &st, int index)
template<class RF, class PR>
void | visit_at_end (RF &rf, PR &pr)
## Public Attributes
MultiArray< 2, double > | variable_importance_

## Detailed Description

calculate variable importance while learning.

## Member Data Documentation

MultiArray<2, double> variable_importance_

This Array has the same entries as the R - random forest variable importance. Matrix is featureCount by (classCount +2) variable_importance_(ii,jj) is the variable importance measure of the ii-th variable according to: jj = 0 - (classCount-1) classwise permutation importance jj = rowCount(variable_importance_) -2 permutation importance jj = rowCount(variable_importance_) -1 gini decrease importance.

permutation importance: The difference between the fraction of OOB samples classified correctly before and after permuting (randomizing) the ii-th column is calculated. The ii-th column is permuted rep_cnt times.

class wise permutation importance: same as permutation importance. We only look at those OOB samples whose response corresponds to class jj.

gini decrease importance: row ii corresponds to the sum of all gini decreases induced by variable ii in each node of the random forest.

The documentation for this class was generated from the following file:

- vigra/random_forest/rf_visitors.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.7.1 (3 Dec 2010)